;
;	DISASSEMBLY OF
;
;	OHIO SCIENTIFIC DOS OS-65D V3.2
;
;	FOR C2/C4 ONLY ???
;
;	ADDR	TRK	SEC	PAGES
;	2200	0		8
;	2A00	1	1	8
;	3200	6	2	1
;

	*=	$2200

	LDA	#1
	STA	L265E
	JSR	L26BC
	LDA	#$2A
	STA	$FF
	JSR	L2754
	STX	$FE
	JSR	L2967
	JSR	L2E79

	STX	$F401
	STX	$F400
	STX	$F403
	DEX
	STX	$DF01
	STX	$F402
	LDA	$FB06
	STX	$FB05
	LDA	#4
	STA	$F401
	STA	$F403

	STY	$C001
	LDY	#$40
	STY	$C000
	STA	$C001

	LDA	#1
	JSR	L29C6

; INIT ACIA ON CPU BOARD

L2245	LDA	#3
	STA	$FC00
	LDY	#$11
	STY	$FC00

; INIT ACIA ON 550 BOARD

	LDX	#$1E
L2251	STA	$CF00,X
	TYA
	STA	$CF00,X
	LDA	#3
	DEX
	DEX
	BPL	L2251

; CLEAR SCREEN

	LDX	#8
	LDA	#$D0
	STA	$FF
	LDY	#0
	STY	$FE
	LDA	#' '
L226A	STA	($FE),Y
	INY
	BNE	L226A
	INC	$FF
	DEX
	BNE	L226A

	STX	0

; FIND TOP OF RAM

	LDY	#$BF
L2278	JSR	L22EC
	BEQ	L2280
	DEY
	BNE	L2278
L2280	STY	L2300

; SET DEFAULT I/O DEVICE

	LDX	#1
	LDA	$FE01
	BEQ	L228B
	INX
L228B	STX	L2AC5+1
	NOP
	LDX	#1
	STX	$DE00
	JMP	L22B3

	CPX	$F022
	CLC

	LDY	#$D7
	JSR	L22EC
	BNE	L22B3
	LDY	#0
L22A4	LDX	L22C7,Y
	BEQ	L22B3
	INY
	LDA	L22C7,Y
	STA	L2599,X
	INY
	BNE	L22A4

L22B3	JSR	L2D73

	.BYTE	$D,$A
	.BYTE	'OS-65D V3.0',0

	JMP	L2AE6

L22C7	.BYTE	$0B,$40
	.BYTE	$8D,$40
	.BYTE	$91,$40
	.BYTE	$AF,$40
	.BYTE	$2D,$80
	.BYTE	$9E,$80
	.BYTE	$A1,$D7
	.BYTE	$2A,$D7
	.BYTE	$34,$D7
	.BYTE	$3C,$D7
	.BYTE	$8B,$D7
	.BYTE	$97,$D7
	.BYTE	$BA,$D7
	.BYTE	$7D,$D7
	.BYTE	$84,$D7
	.BYTE	$80,$B1
	.BYTE	$87,$AA
	.BYTE	$31,$00
	.BYTE	0

L22EC	STY	$FF
	LDA	($FE),Y
	AND	#$3F
	EOR	#$3F
	STA	($FE),Y
	STA	$FD
	LDA	($FE),Y
	AND	#$3F
	CMP	$FD
	RTS

	.BYTE	$24
L2300	.BYTE	0

; CHARACTER I/O DISPATCH TABLE

L2301	.WORD	$24F5
	.WORD	$252A
	.WORD	$2517
	.WORD	$2385
	.WORD	$2388
	.WORD	$23A0
	.WORD	$23EF
	.WORD	$24AF

	.WORD	$24CC
	.WORD	$2598
	.WORD	$250C
	.WORD	$249E
	.WORD	$238F
	.WORD	$23B1
	.WORD	$2402
	.WORD	$24BC

L2321	.BYTE	$10
L2322	.BYTE	0
L2323	.BYTE	0
L2324	.BYTE	0
L2325	.BYTE	0
L2326	.WORD	L327E
L2328	.WORD	$3A7E
	.BYTE	$50 ; P
L232B	.BYTE	$51 ; Q
L232C	.BYTE	$50 ; P
L232D	.BYTE	0
L232E	.WORD	$3A7E
	.WORD	$427E
	.BYTE	$50 ; P
	.BYTE	$51 ; Q
	.BYTE	$50 ; P
L2335	.BYTE	0

L2336	JMP	L2CD6

L2339	LDY	#0
	LDA	L2321
	BNE	L234B
L2340	JSR	L2336
L2343	JSR	L2367
L2346	LDA	L2322
	LDY	#$10
L234B	LDX	#$FF
	BNE	L2371

L234F	INX
	LSR	A
	BCC	L235C
	PHA
	TXA
	PHA
	JSR	L2376
	PLA
	TAX
	PLA
L235C	BNE	L234F
L235E	LDX	#0
L2360	LDY	#0
L2362	LDA	#0
	AND	#$7F
	RTS

L2367	STA	L2362+1
	STY	L2360+1
	STX	L235E+1
	RTS

L2371	STY	L2377+1
	BNE	L234F
L2376	ASL	A
L2377	ADC	#0
	TAX
	LDA	L2301+1,X
	PHA
	LDA	L2301,X
	PHA
	LDA	L2362+1
	RTS

	LDA	#0
	RTS
L2389	LDA	L2E25
	LDX	#0
L238E	BEQ	L2395
L2390	STA	$8000
	LDX	#7
L2395	STA	L2362+1
	INC	L2389+1,X
L239B	BNE	L23A0
	INC	L2389+2,X
L23A0	RTS

	LDY	#0
	JSR	L2466
	BNE	L23AB
	JSR	L23CC
L23AB	LDA	L317D+1
	LDX	#$22 ; '"'
L23B0	BNE	L2395
	CMP	#$A
	BEQ	L23A0
	PHA
	LDY	#$17
	JSR	L2466
	BNE	L23C1
	JSR	L23CC
L23C1	PLA
L23C2	STA	L317D+1
	LDX	#$39 ; '9'
	STX	L232D
	BNE	L2395

L23CC	LDA	L232D
	BEQ	L23D6
	LDX	#0
	JSR	L2477
L23D6	LDA	L2326
	STA	L23AB+1
	STA	L23C2+1
	STA	$FE
	LDA	L2326+1
	STA	L23AB+2
	STA	L23C2+2
	STA	$FF
	LDX	#0
L23EE	BEQ	L2442
	LDX	#8
	LDY	#$51 ; 'Q'
	JSR	L2468
	BNE	L23FC
	JSR	L2420
L23FC	LDA	$3D7E
	LDX	#$73 ; 's'
L2401	BNE	L2395
	CMP	#$A
	BEQ	L2476
	PHA
	LDX	#8
	LDY	#$6A ; 'j'
	JSR	L2468
	BNE	L2414
	JSR	L2420
L2414	PLA
L2415	STA	$3D7E
	LDX	#$8C
	STX	L2335
	JMP	L2395

L2420	LDA	L2335
	BEQ	L242A
	LDX	#8
	JSR	L2477
L242A	LDA	L232E
	STA	L23FC+1
	STA	L2415+1
	STA	$FE
	LDA	L232E+1
	STA	L23FC+2
	STA	L2415+2
	STA	$FF
	LDX	#8
L2442	LDA	L232C,X
	CLC
	SED
	ADC	#1
	CLD
	STA	L232C,X
	JSR	L2453
	JMP	L2B1D

L2453	LDA	#0
	STA	L232D,X
	LDA	L232C,X
	CMP	L232B,X
	JSR	L2C8D
	INY
	BNE	L2491

	.BYTE	0
	.BYTE	0

L2466	LDX	#0
L2468	LDA	L23AB+1,Y
	CMP	L2328,X
	BNE	L2476
	LDA	L23AB+2,Y
	CMP	L2328+1,X
L2476	RTS

L2477	LDA	L2328+1,X
	SEC
	SBC	L2326+1,X
	STA	L265F
	LDA	L2326,X
	STA	$FE
	LDA	L2326+1,X
	STA	$FF
	JSR	L2453
	JMP	L27E1

L2491	STY	L265E
	JMP	L2754

L2497	LDA	#$80
	STA	L2389+2
	LDA	#0
	RTS

	PHA
L24A0	LDA	$F400
	LSR	A
	BCS	L24A0
	PLA
	AND	#$7F
	STA	$F402
	LDA	$F420
	RTS
L24B0	LDX	L2323
	LDA	$CF00,X
	LSR	A
	BCC	L24B0
	BCS	L2508

	.BYTE	0
	.BYTE	0

	PHA
L24BE	LDX	L2323
	LDA	$CF00,X
	LSR	A
	LSR	A
	BCC	L24BE
	PLA
	STA	$CF01,X
	RTS

	PHA
L24CE	LDA	$FC00
	LSR	A
	LSR	A
	BCC	L24CE
	PLA
	STA	$FC01
	PHA
	LDA	$FC00
	LSR	A
	BCC	L24F1
	JSR	L24F6
	STA	L2325
	CMP	#$13
	BNE	L24F1
L24EA	JSR	L24F6
	CMP	#$11
	BNE	L24EA
L24F1	PLA
	STA	L2362+1
	RTS

L24F6	LDA	$FC00
	INC	L2324
	LSR	A
	BCC	L24F6
	LDA	$FC01
	AND	#$7F
L2504	STA	L2362+1
	RTS

L2508	LDA	$CF01,X
L250B	BCS	L2504
	PHA
L250E	LDA	$FB05
	BPL	L250E
	PLA
	STA	$FB04
	RTS

L2518	LDA	$FB05
	LSR	A
	BCC	L2518
	LDA	$FB03
	STA	$FB07
	STA	L2362+1
	RTS

L2528	JSR	L2544

L252B	JSR	L2644
L252E	INC	L2324
	JSR	L3180
	BEQ	L252E
	STA	L2362+1
	JSR	L2644
	LDA	L2362+1
	RTS

L2540	STA	L2325
	PLA
L2544	JMP	L2504

	JSR	L2644
	JMP	L2A51

L254D	CMP	#$5B ; '['
	BNE	L2562
	LDA	#$80
	STA	L2390+2
	LDA	#0
	STA	L2390+1
	LDA	L2322
	ORA	#$10
	BNE	L2593

L2562	CMP	#$5D ; ']'
	BNE	L2579
	JSR	L2346
	LDA	L2AC5+1
	STA	L2321
	LDA	L2322
	AND	#$EF
	STA	L2322
	LDA	#$5D ; ']'

L2579	CMP	#$18
	BNE	L258A
	LDA	#$10
	STA	L2321
	JSR	L2497
	STA	L2389+1
	BCS	L2596

L258A	CMP	#$10
	BNE	L2598
	LDA	L2322
	EOR	#8
L2593	STA	L2322
L2596	LDA	#0
L2598	RTS

;

L2599	TYA
	PHA
	LDY	L263C
	LDA	L2362+1
	AND	#$7F
L25A3	LDX	#$40
	CMP	#$D
	BEQ	L2603
	CMP	#$A
	BEQ	L260F
	CMP	#8
	BEQ	L25F5
	CMP	#$10
	BEQ	L25FC
	CMP	#$C
	BEQ	L25FC
	CMP	#$20 ; ' '
	BMI	L25D7
	CMP	#$7B ; '{'
	BPL	L25D7
	STA	$D700,X
	INX
	CPX	#$80
	BEQ	L260B
L25C9	LDY	$D700,X
	STY	L263C
	LDA	#$5F ; '_'
	STA	$D700,X
	STX	L25A3+1

;

L25D7	PLA
	TAY
	LDA	#1
	JSR	L263D
	BVC	L2643
	LDA	#8
	JSR	L263D
	BPL	L2643
	LDA	L2362+1
	PHA
L25EB	JSR	L252B
	CMP	#$13
	BEQ	L25EB
	JMP	L2540

L25F5	TYA
	STA	$D700,X
	DEX
	BCS	L25C9
L25FC	TYA
	STA	$D700,X
	INX
	BCS	L25C9
L2603	TYA
	STA	$D700,X
	LDX	#$40
	BNE	L25C9

L260B	LDX	#$40
	BNE	L2613

L260F	TYA
	STA	$D700,X
L2613	STX	L2638+1
	LDA	#' '
	LDX	#$80
L261A	STA	$D700,X
	INX
	BNE	L261A
	LDY	#$CF
L2622	INY
	STY	L2629+2
	STY	L262C+2
L2629	LDA	$D040,X
L262C	STA	$D000,X
	INX
	BEQ	L2622
	BPL	L2629
	CPY	#$D7
	BCC	L2629
L2638	LDX	#0
	BNE	L25C9

L263C	.BYTE	$20

L263D	STA	$DF00
	BIT	$DF00
L2643	RTS

L2644	LDX	#3
L2646	LDA	$213,X
	LDY	L2657,X
	STA	L2657,X
	TYA
	STA	$213,X
	DEX
	BPL	L2646
	RTS

L2657	.BYTE	$00
	.BYTE	$4C
	.BYTE	$CB
	.BYTE	$25

	.BYTE	$20
L265C	.BYTE	1
L265D	.BYTE	0
L265E	.BYTE	0
L265F	.BYTE	0
L2660	.BYTE	0
L2661	.BYTE	0
L2662	.BYTE	0

L2663	JSR	L268A
	JSR	L2678
	STY	L265D
L266C	LDA	#2
	BIT	$C000
	BEQ	L2678
	JSR	L2683
	BEQ	L266C

L2678	LDX	#$C
L267A	LDY	#$31 ; '1'
	JSR	L2707
	DEX
	BNE	L267A
L2682	RTS

L2683	LDA	$C002
	ORA	#4
	BNE	L268F
L268A	LDA	#$FB
	AND	$C002
L268F	STA	$C002
	JSR	L2682
	AND	#$F7
	JSR	L2719
	JSR	L270D
L269D	ORA	#8
	JSR	L2719
	LDX	#8
	BNE	L267A
	LDA	L2662
	SEC
	LDX	#$FF
L26AC	INX
	SBC	#$A
	BCS	L26AC
	ADC	#$A
	STA	$FA
	TXA
	ASL	A
	ASL	A
	ASL	A
	ASL	A
	ORA	$FA
L26BC	STA	$FA
	PHA
	BIT	L269D+1
	BEQ	L26C8
	AND	#6
	BNE	L26CD
L26C8	PLA
	CMP	#$40 ; '@'
	BCC	L26D1
L26CD	LDA	#8
	BNE	L26DE

L26D1	LDA	L265C
	AND	#1
	TAY
	JSR	L29DA
	BCC	L26E1
	LDA	#6
L26DE	JMP	L2A4B

L26E1	LDA	$FA
	CMP	L265D
	BEQ	L270F
	BCS	L26F1
	JSR	L2683
	LDA	#$99
	BCC	L26F5
L26F1	JSR	L268A
	TXA
L26F5	SED
	ADC	L265D
	STA	L265D
	CLD
	JMP	L26E1

L2700	LDA	$FA
	ASL	A
	ASL	A
	ASL	A
	TAX
	RTS

L2707	JSR	L239B
	DEY
	BNE	L2707
L270D	NOP
	RTS

L270F	LDY	#0
	RTS

	BCS	L2719
	LDA	#$40 ; '@'
L2716	ORA	$C002
L2719	STA	$C002
	RTS

L271D	LDA	$C000
	BMI	L271D
L2722	LDA	$C000
	BPL	L2722
	RTS

L2728	JSR	L2754
L272B	JSR	L271D
	LDA	#3
	STA	$C010
	LDA	#$58
	STA	$C010
	RTS

L2739	JSR	L2728
L273C	LDA	$C000
	BPL	L2761
	LDA	$C010
	LSR	A
	BCC	L273C
	LDA	$C011
	STA	($FE),Y
	INY
	BNE	L273C
	INC	$FF
	JMP	L273C

L2754	LDA	#$7F
	AND	$C002
L2759	STA	$C002
	LDX	#$28
	JMP	L267A

L2761	LDA	#$80
L2763	ORA	$C002
	BNE	L2759
L2768	LDA	#$39 ; '9'
	STA	$E5
	JSR	L2663
L276F	JSR	L2C83
	JSR	L277D
	LDA	L265D
	CMP	#$39 ; '9'
	BNE	L276F
	RTS

L277D	LDA	#2
	BIT	$C000
	BNE	L2788
	LDA	#3
	BNE	L2791

L2788	LDA	#$20
	BIT	$C000
	BNE	L2794
	LDA	#4
L2791	JMP	L2A4B

L2794	JSR	L2728
	LDA	#$FC
	AND	$C002
	STA	$C002
	LDX	#$A
	JSR	L267A
	LDX	#'C'
	JSR	L27C2
	LDX	#'W'
	JSR	L27C2
	LDX	L265D
	JSR	L27C2
	LDX	#'X'
	JSR	L27C2
L27B9	LDA	$C000
	BMI	L27B9
	LDA	#$83
	BNE	L2763

L27C2	LDA	$C010
	LSR	A
	LSR	A
	BCC	L27C2
	STX	$C011
	RTS

L27CD	LDA	$C010
	LSR	A
	BCC	L27CD
	LDA	$C011
L27D6	RTS

	LDA	L2660
	STA	$FE
	LDA	L2661
	STA	$FF
L27E1	LDA	L265F
	BEQ	L27E8
	BPL	L27EC
L27E8	LDA	#$B
L27EA	BNE	L2791
L27EC	CMP	#9
	BPL	L27E8
	LDA	#2
	BIT	$C000
	BEQ	L27D6
	LSR	A
	STA	$FA
	LDA	#$20
	BIT	$C000
	BNE	L2805
	LDA	#4
	BNE	L27EA

L2805	LDA	#1
	STA	$F6
L2809	LDA	#3
	STA	$F8
	JSR	L28C4
	JSR	L289F
	LDA	#$FE
	AND	$C002
	STA	$C002
	LDX	#2
	JSR	L28A2
	LDA	#$FF
	AND	$C002
	STA	$C002
	JSR	L289F
	LDX	#'v'
	JSR	L27C2
	LDX	L265E
	JSR	L27C2
	LDX	L265F
	STX	$FD
	JSR	L27C2
	LDY	#0
L2840	LDA	($FE),Y
	TAX
	JSR	L27C2
	INY
	BNE	L2840
	INC	$FF
	DEC	$FD
	BNE	L2840
	LDX	#'G'
	JSR	L27C2
	LDX	#'S'
	JSR	L27C2
	LDA	L265F
	ASL	A
	STA	$FD
	ASL	A
	ADC	$FD
	TAX
	JSR	L28A2
	LDA	$C002
	ORA	#1
	STA	$C002
	LDX	#5
	JSR	L28A2
	LDA	#2
	JSR	L2716
L2878	CLC
	TXA
	ADC	$FF
	SEC
	SBC	L265F
	STA	$FF
	JSR	L2905
	BCS	L28AF
	DEC	$F8
	BNE	L2878
	DEC	$F6
	BMI	L289B
	TXA
	ADC	$FF
	SEC
	SBC	L265F
	STA	$FF
	JMP	L2809
L289B	LDA	#2
	BNE	L28C1

L289F	JSR	L2700
L28A2	LDA	L267A+1
L28A5	BIT	0
	SEC
	SBC	#5
	BCS	L28A5
	DEX
	BNE	L28A2
L28AF	RTS

L28B0	LDA	$C000
L28B3	BPL	L28BF
	LDA	$C010
	LSR	A
	BCC	L28B0
	LDA	$C011
	RTS

L28BF	LDA	#9
L28C1	JMP	L2A4B

L28C4	JSR	L272B
L28C7	JSR	L28B0
L28CA	CMP	#'C'
	BNE	L28C7
	JSR	L28B0
	CMP	#'W'
	BNE	L28CA
	JSR	L27CD
	CMP	L265D
	BEQ	L28E1
	LDA	#5
	BNE	L28C1
L28E1	JSR	L27CD
	DEC	L265E
	BEQ	L28FD
	LDA	#0
	STA	$F9
L28ED	JSR	L2998
	BCC	L2901
	LDA	L265E
	CMP	$F9
	BNE	L28ED
	CMP	$FB
	BNE	L2901
L28FD	INC	L265E
	RTS
L2901	LDA	#$A
	BNE	L28C1
L2905	PHA
	JSR	L28C4
L2909	JSR	L28B0
	CMP	#'v'
	BNE	L2909
	JSR	L27CD
	CMP	L265E
	BEQ	L291B
	PLA
L2919	CLC
	RTS
L291B	JSR	L27CD
	TAX
	STA	L265F
	LDY	#0
	PLA
	BEQ	L2943

L2927	LDA	$C010
	LSR	A
	BCC	L2927
	LDA	$C011
	BIT	$C010
	BVS	L2919
	CMP	($FE),Y
	BNE	L2919
	INY
	BNE	L2927
	INC	$FF
	DEX
	BNE	L2927
	SEC
	RTS

L2943	LDA	$C010
	LSR	A
	BCC	L2943
	LDA	$C011
	BIT	$C010
	BVS	L2919
	STA	($FE),Y
	INY
	BNE	L2943
	INC	$FF
	DEX
	BNE	L2943
	SEC
	RTS

	LDA	L2660
	STA	$FE
	LDA	L2661
	STA	$FF
L2967	LDA	#3
	STA	$F7
L296B	LDA	#7
	STA	$F8
L296F	LDA	#0
	JSR	L2905
	BCC	L297A
	RTS

L2977	DEC	$FF
	INX
L297A	CPX	L265F
	BNE	L2977
	DEC	$F8
	BNE	L296F
	JSR	L2683
	JSR	L2678
	JSR	L268A
	JSR	L2678
	DEC	$F7
	BPL	L296B
	LDA	#1
	JMP	L2A4B

L2998	LDA	$C000
	BPL	L29C4
	LDA	$C010
	LSR	A
	BCC	L2998
	LDA	$C011
	CMP	#'v'
	BNE	L2998
	JSR	L27CD
	STA	$FB
	JSR	L27CD
	STA	$FA
	INC	$F9
	TAY
	LDX	#0
L29B9	JSR	L27CD
	DEX
	BNE	L29B9
	DEY
	BNE	L29B9
	SEC
	RTS
L29C4	CLC
	RTS

L29C6	STA	L265C
	ASL	A
	TAX
	AND	#2
	TAY
	LDA	L29E9,X
	STA	$C000
	LDA	L29EA,X
	STA	$C002
L29DA	LDA	$C000
	LSR	A
	PHP
	CPY	#0
	BNE	L29E9
	PLP
	LSR	A
	LSR	A
	LSR	A
	LSR	A
	RTS
L29E9	PLP
L29EA	RTS

	.BYTE	$40
	.BYTE	$FF
	.BYTE	0
	.BYTE	$FF
	.BYTE	$40
	.BYTE	$DF
	.BYTE	0
	.BYTE	$DF

L29F3	TAX
	BEQ	L29C4
	PHA
	JSR	L26BC
	JSR	L2D73

	.BYTE	$D,$A
	.BYTE	'TRACK ',0

	PLA
	JSR	L2D92
	TSX
	STX	$FC
	JSR	L2754
	INX
	STX	L265E
	JSR	L28C4
	LDA	#0
	STA	$F9
L2A1B	JSR	L2998
	LDA	$FB
	PHA
	LDA	$FA
	PHA
	BCS	L2A1B
	LDX	$FC
	BCC	L2A37
L2A2A	JSR	L2D6A
	LDA	#' '
	JSR	L2A41
	LDA	#'-'
	JSR	L2A41
L2A37	DEC	$F9
	BPL	L2A2A
	LDX	$FC
	TXS
	JMP	L2761

L2A41	JSR	L2343
	LDA	$100,X
	DEX
	JMP	L2D92

L2A4B	JSR	L2AC4
L2A4E	JMP	L2A51

L2A51	LDX	#$28
	TXS
	LDA	#$51
	LDY	#$2A
	JSR	L2A7D
	JSR	L2D6A
	LDA	L265C
	CLC
	ADC	#$40
	JSR	L2343
	LDA	#'*'
	JSR	L2343
	JSR	L2C9B
	LDA	#$2E
	STA	$E2
	LDA	#$1E
	STA	$E1
	JSR	L2A84
	JMP	L2A51

L2A7D	STA	L2A4E+1
	STY	L2A4E+2
	RTS

L2A84	LDX	#0
	STX	L2CE4+1
L2A89	LDY	#0
	LDA	L2E30,X
	BEQ	L2AC0
	CMP	($E1),Y
	BNE	L2ABA
	INY
	LDA	L2E30+1,X
	CMP	($E1),Y
	BNE	L2ABA
	LDA	L2E32+1,X
	PHA
	LDA	L2E32,X
	PHA
L2AA4	JSR	L2CE4
	CMP	#$D
	BEQ	L2AB9
	CMP	#$20 ; ' '
	BNE	L2AA4
L2AAF	JSR	L2CE4
	CMP	#$20 ; ' '
	BEQ	L2AAF
	DEC	L2CE4+1
L2AB9	RTS

L2ABA	INX
	INX
	INX
	INX
	BNE	L2A89
L2AC0	LDA	#7
	BNE	L2A4B
L2AC4	PHA
L2AC5	LDA	#1
	STA	L2321
	STA	L2322
	JSR	L2D73

	.BYTE	' ERR #',0

	PLA
	JSR	L2D9B
L2ADB	JMP	L2761

	LDA	#7
	JSR	L2AEE
L2AE3	JMP	$1300

L2AE6	LDA	#2
	JSR	L2AEE
	JMP	$20E4

L2AEE	JSR	L26BC
	LDX	#2
	STX	$E0
	STX	$FF
	DEX
	STX	L265E
	DEX
	STX	$FE
	DEX
	STX	$E5
	JSR	L3179
L2B04	JSR	L2967
	DEC	$E0
	BMI	L2B20
	JSR	L2C83
	JMP	L2B04

	JSR	L2D23
	JSR	L2D58
	JSR	L2C60
L2B1A	JSR	L2754
L2B1D	JSR	L2967
L2B20	JMP	L2761

	LDA	#0
	STA	L28B3+1
	RTS

	JSR	L2D2E
	JMP	L29F3

	LDA	#7
	JSR	L2AEE
	JMP	$1700

	JSR	L2D23
	JSR	L2D58
	JSR	L2D2E
	JSR	L26BC
	JMP	L2739

	JSR	L2D2E
	STA	L2B52+2
	JSR	L2D2E
	STA	L2B52+1
L2B52	JMP	$FFFF

	JSR	L2CE4
	CMP	#$D
	BEQ	L2B68
	DEC	L2CE4+1
	JSR	L2D2E
	JSR	L26BC
	JMP	L277D
L2B68	JSR	L2D73

	.BYTE	'ARE YOU SURE?',0

	JSR	L2340
	CMP	#'Y'
	BNE	L2BA6
	JMP	L2768

	JSR	L2CE4
	CMP	#$2C ; ','
	BEQ	L2BA0
	DEC	L2CE4+1
	JSR	L2D2E
	STA	L2321
	JSR	L2CE4
	CMP	#$D
	BEQ	L2BA6
	DEC	L2CE4+1
	JSR	L2D5B
L2BA0	JSR	L2D2E
	STA	L2322
L2BA6	RTS

L2BA7	JSR	L2DA6
	JSR	L2C70
	STX	$E0
	BEQ	L2BB4
L2BB1	JSR	L2C83
L2BB4	JSR	L2967
	INC	$E0
	DEC	L327D
	BNE	L2BB1
	LDA	$E0
	STA	L327D
	JMP	L2761

	LDX	#0
	JSR	L2BD0
	JSR	L2D5B
	LDX	#7
L2BD0	JSR	L2D2E
	STA	L2389+2,X
	JSR	L2D2E
	STA	L2389+1,X
	RTS

	JSR	L2DA6
	JSR	L2C70
	LDA	L327D
	STA	$E0
	LDA	#8
	STA	L265F
L2BED	JSR	L27E1
	DEC	$E0
	BEQ	L2BFA
	JSR	L2C83
	JMP	L2BED

L2BFA	JMP	L2761

	JSR	L2CE4
	CMP	#'A'
	BNE	L2C07
	JMP	$1303
L2C07	CMP	#'B'
	BNE	L2C0E
	JMP	L2AC0
L2C0E	CMP	#'E'
	BNE	L2C15
	JMP	$1700
L2C15	CMP	#'M'
	BNE	L2C1F
	JSR	L2644
	JMP	($FEFC)
L2C1F	JMP	L2AC0

	JSR	L2BA7
	JMP	L327E

	JSR	L2C60
	JSR	L2D58
	JSR	L2D23
	JSR	L2D5E
	JSR	L2D3D
	STA	L265F
	JSR	L2754
	JSR	L27E1
	JMP	L2761

	JSR	L2CE4
	CMP	#'A'
	BMI	L2C58
	CMP	#'E'
	BPL	L2C58
	AND	#$F
	JSR	L29C6
	BCS	L2C5B
	JMP	L2663

L2C58	JMP	L2AC0

L2C5B	LDA	#6
L2C5D	JMP	L2A4B

L2C60	JSR	L2D2E
	JSR	L26BC
	JSR	L2D5B
	JSR	L2D3D
	STA	L265E
	RTS

L2C70	JSR	L26BC
	LDA	#$32
	STA	$FF
	LDA	#$79
	STA	$FE
	LDA	#1
	STA	L265E
	JMP	L2754

L2C83	LDA	L265D
	CLC
	SED
	ADC	#1
	CLD
	CMP	$E5
L2C8D	BEQ	L2C91
	BCS	L2C94
L2C91	JMP	L26BC

L2C94	LDA	#$D
	BNE	L2C5D

L2C98	JSR	L2D6A
L2C9B	LDA	#$11
	STA	L2CEC+1
	LDX	#0
L2CA2	JSR	L2340
	CMP	#$5F ; '_'
	BNE	L2CBC
	DEX
	BMI	L2C98
	STA	L2E1E,X
	JSR	L2D73

	.BYTE	8,8,'  ',8,8,0

	JMP	L2CA2

L2CBC	CMP	#$15
	BEQ	L2C98
L2CC0	STA	L2E1E,X
	CMP	#$D
	BEQ	L2CD0
	INX
	CPX	#$11
	BNE	L2CA2
	LDA	#$D
	BNE	L2CC0
L2CD0	JMP	L2D6A

	.BYTE	0
	.BYTE	0
	.BYTE	0

L2CD6	JSR	L2367
L2CD9	JSR	L2339
	JSR	L254D
	BEQ	L2CD9
	JMP	L235E
L2CE4	LDY	#0
	LDA	($E1),Y
	CMP	#$D
	BEQ	L2CF3
L2CEC	CPY	#$11
	BEQ	L2CF4
	INC	L2CE4+1
L2CF3	RTS

L2CF4	LDA	#$D
	RTS

L2CF7	PLA
	CLC
	ADC	#1
	STA	L2D20+1
	PLA
	ADC	#0
	STA	L2D20+2
	LDX	#0
L2D06	LDA	$100,X
	LDY	L3079,X
	STA	L3079,X
	TYA
	STA	$100,X
	LDA	0,X
	LDY	L2F79,X
	STA	L2F79,X
	STY	0,X
	INX
	BNE	L2D06
L2D20	JMP	L2245

L2D23	JSR	L2D2E
	STA	$FF
	JSR	L2D2E
	STA	$FE
	RTS

L2D2E	JSR	L2D3D
	ASL	A
	ASL	A
	ASL	A
	ASL	A
	STA	$E0
	JSR	L2D3D
	ORA	$E0
	RTS

L2D3D	JSR	L2CE4
	SEC
	SBC	#$30 ; '0'
	CMP	#$A
	BCC	L2D4F
	SBC	#$11
	CMP	#6
	BCS	L2D55
	ADC	#$A
L2D4F	RTS

	LDA	0
	BEQ	L2CF7
	RTS
L2D55	JMP	L2AC0

L2D58	LDA	#'='
	.BYTE	$2C
L2D5B	LDA	#','
	.BYTE	$2C
L2D5E	LDA	#'/'
	STA	$E0
	JSR	L2CE4
	CMP	$E0
	BNE	L2D55
	RTS

L2D6A	LDA	#$D
	JSR	L2343
	LDA	#$A
	BNE	L2DA3

L2D73	PLA
	STA	$E3
	PLA
	STA	$E4
	LDY	#1
L2D7B	LDA	($E3),Y
	BEQ	L2D85
	JSR	L2343
	INY
	BNE	L2D7B
L2D85	TYA
	SEC
	ADC	$E3
	STA	$E3
	BCC	L2D8F
	INC	$E4
L2D8F	JMP	($E3)

L2D92	PHA
	LSR	A
	LSR	A
	LSR	A
	LSR	A
	JSR	L2D9B
	PLA
L2D9B	AND	#$F
	CMP	#$A
	SED
	ADC	#$30 ; '0'
	CLD
L2DA3	JMP	L2343

L2DA6	LDA	#$39 ; '9'
	STA	$E5
	JSR	L2CE4
	DEC	L2CE4+1
	CMP	#$41 ; 'A'
	BPL	L2DBE
	LDX	#0
	LDA	#$39 ; '9'
	STA	$2E7A,X
	JMP	L2D2E
L2DBE	LDA	L2CE4+1
	STA	$E0
	LDA	#$12
	JSR	L26BC
	STY	L265E
	JMP	L2E00

	LDX	#0
L2DD0	JSR	L2CE4
	CMP	#$D
	BNE	L2DD9
	LDA	#$20 ; ' '
L2DD9	CMP	L2E79,X
	BNE	L2DEF
	INX
	TXA
	AND	#7
	CMP	#6
	BNE	L2DD0
	LDA	L2E79+1,X
	STA	$E5
	LDA	L2E79,X
	RTS
L2DEF	TXA
	AND	#$F8
	CLC
	ADC	#8
	TAX
	BEQ	L2E00
L2DF8	LDA	$E0
	STA	L2CE4+1
	JMP	L2DD0

L2E00	INC	L265E
	LDA	L265E
	CMP	#3
	BMI	L2E0F
	LDA	#$C
	JMP	L2A4B

L2E0F	LDA	#$79
	STA	$FE
	LDA	#$2E
	STA	$FF
	JSR	L2B1A
	LDX	#0
	BEQ	L2DF8

L2E1E	.BYTE	$D,0,0,0,0,0,0
L2E25	.BYTE	'RUN"BEXEC*',$D

L2E30	.BYTE	'AS'
L2E32	.WORD	$2ADD
	.BYTE	'BA'
	.WORD	$2AE5
	.BYTE	'CA'
	.WORD	$2B10
	.BYTE	'D9'
	.WORD	$2ABF
	.BYTE	'DI'
	.WORD	$2B28
	.BYTE	'EM'
	.WORD	$2B2E
	.BYTE	'EX'
	.WORD	$2B36
	.BYTE	'GO'
	.WORD	$2B45
	.BYTE	'HO'
	.WORD	$2662
	.BYTE	'IN'
	.WORD	$2B54
	.BYTE	'IO'
	.WORD	$2B82
	.BYTE	'LO'
	.WORD	$2BA6
	.BYTE	'ME'
	.WORD	$2BC5
	.BYTE	'PU'
	.WORD	$2BDC
	.BYTE	'RE'
	.WORD	$2BFC
	.BYTE	'XQ'
	.WORD	$2C21
	.BYTE	'SA'
	.WORD	$2C27
	.BYTE	'SE'
	.WORD	$2C42
	.BYTE	0

L2E79	INC	L265E
	LDA	#6
	JSR	L26BC
	JSR	L2967
	LDA	#$34
	STA	$F701
	LDX	#0
	LDY	#0
L2E8D	INX
	BEQ	L2EB0
L2E90	INY
	BEQ	L2E8D
	LDA	$DE00
	BMI	L2E90
	LDY	#1
L2E9A	LDA	$DE00
	BPL	L2E9A
L2E9F	INY
	BEQ	L2EB0
	LDX	#$1F
L2EA4	DEX
	BNE	L2EA4
	LDA	0
	LDA	$DE00
	BMI	L2E9F
	BPL	L2EB2

L2EB0	LDY	#$31 ; '1'
L2EB2	STY	L267A+1
	LDY	#0
	RTS

	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0

L2F79	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

L3079	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

L3179	LDA	#4
	STA	$E0
L317D	JMP	L2754

L3180	TXA
	PHA
	TYA
	PHA
	LDA	#1
L3186	STA	$DF00
	LDX	$DF00
	BNE	L3193
L318E	ASL	A
	BNE	L3186
	BEQ	L31E6

L3193	LSR	A
	BCC	L319F
	ROL	A
	CPX	#$21 ; '!'
	BNE	L318E
	LDA	#$1B
	BNE	L31C0
L319F	JSR	$FDC8

;LFDC8	LDY	#8
;LFDCA	DEY
;	ASL	A
;	BCC	LFDCA
;	RTS

	TYA
	STA	$213
	ASL	A
	ASL	A
	ASL	A
	SEC
	SBC	$213
	STA	$213
	TAY
	TXA
	LSR	A
	BEQ	L31E6
	DEY
L31B6	INY
	LSR	A
	BCC	L31B6
	BNE	L31E6
	NOP
	LDA	$FDCF,Y

; KEYBOARD MATRIX
;
;LFDCF	.BYTE	$D0,$BB,'/',$20,'Z','A','Q'
;	.BYTE	',','M','N','B','V','C','X'
;	.BYTE	'K','J','H','G','F','D','S'
;	.BYTE	'I','U','Y','T','R','E','W'
;	.BYTE	$00,$00,$0D,$0A,'O','L','.'
;	.BYTE	$00,$FF,'-',$BA,'0',$B9,$B8
;	.BYTE	$B7,$B6,$B5,$B4,$B3,$B2,$B1

L31C0	CMP	$215
	BNE	L31EB
	DEC	$214
	BEQ	L31F5
	LDY	#5
L31CC	LDX	#$C8
L31CE	DEX
	BNE	L31CE
	DEY
	BNE	L31CC
	BEQ	L3219

L31D6	CMP	#1
	BEQ	L320F
	LDY	#0
	CMP	#2
	BEQ	L3216
	LDY	#$C0
	CMP	#$20 ; ' '
	BEQ	L3216
L31E6	LDA	#0
	STA	$216
L31EB	STA	$215
	LDA	#2
	STA	$214
	BNE	L3219
L31F5	LDX	#$96
	CMP	$216
	BNE	L31FE
	LDX	#$E
L31FE	STX	$214
	STA	$216
	LDA	#1
	STA	$DF00
	LDA	$DF00
	LSR	A
	BCC	L3212
L320F	JMP	$FD8F

;LFD8F	TAX
;	AND	#3
;	BEQ	LFD9F
;	LDY	#$10
;	LDA	$215
;	BPL	LFDA7
;	LDY	#$F0
;	BNE	LFDA7
;
;LFD9F	LDY	#0
;	CPX	#$20 ; ' '
;	BNE	LFDA7
;	LDY	#$C0
;LFDA7	LDA	$215
;	AND	#$7F
;	CMP	#$20 ; ' '
;	BEQ	LFDB7
;	STY	$213
;	CLC
;	ADC	$213
;LFDB7	STA	$213
;	PLA
;	TAY
;	PLA
;	TAX
;	LDA	$213
;	RTS

L3212	BNE	L31D6
	LDY	#$20 ; ' '
L3216	JMP	$FDA7

L3219	LDA	#0
	JMP	$FDB7

	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0

L3279	.BYTE	0
	.BYTE	0
	.BYTE	0
	.BYTE	0
L327D	.BYTE	0
L327E	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.BYTE	0,0

	.END
