/// Monitor feature Calls

////////////////////////////////////////////////////////////////////////////
#ifndef _MONITOR_H
#define _MONITOR_H

void display_registers();
char *binary(BYTE byte);

BOOL CALLBACK Monitor(HWND hdlg, UINT msg, WPARAM wparam, LPARAM lparam);
BOOL CALLBACK EditIntercept(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
void Open_Monitor(HWND hwnd, char *msg);
void Close_Monitor();


extern HWND	hWndMonitor;

extern BOOL PokeFlag;					// Set if Memory Write
extern BOOL DEnable;                    // Enables Debug Display
extern BOOL DebugRDY;					// Debug Status Flag
extern BOOL CodeERR;					// Enables Error Code handling
extern BOOL SMode;						// Defines present Mode (FALSE=Step Mode)
extern BOOL SEnable;				    // Enables Debug Step

extern char string[256];                // short string buffer
extern char buffer[8192];               // used to print text
extern char tmp[8192];                  // used to store temp data


#endif _MONITOR_H


